// Group.h: interface for the CGroup class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __GROUP_HEADER__
#define __GROUP_HEADER__

#pragma once

#include "IShellBrowserImpl.h"

class CDropTarget;

class CGroup: public IShellBrowserImpl
{
public:
	CGroup(const char *szName);
	virtual ~CGroup();

	bool ReadSettings();
	bool InitFolderView();

	void Show();
	void Toggle();
	void Hide();
	void Reset();
	void SortByName();
	void SortBySize();
	void SortByType();
	void SortByDate();
	void SetTextColor(COLORREF crColor);
	void SetTextBkColor(COLORREF crColor);
	void SetBackground(const char *szBackground, int nOffsetPercentX, int nOffsetPercentY, bool bTiled);
	void SetBackgroundColor(COLORREF crColor);
	//void Hook(HWND hParent);
	void ToggleExplorerDesktop();

	void SaveState();
	void RestoreState();

	IDropTarget* GetLastItemTarget(bool *pbExecute);
	void Drop(DWORD grfKeyState, POINTL *pt, DWORD *pdwEffect, CIDA *pida, POINT *pOffsets);
	void SetDropHover(POINTL *pt, DWORD *pdwEffect);
	void ClearDropHover();

	char*	m_szName;
	
	HWND	m_hwndView;
	HWND	m_hwndListView;
	HFONT	m_hFont;
	COLORREF m_crBackgroundColor;
	COLORREF m_crTextColor;
	COLORREF m_crTextBackgroundColor;
	CDropTarget *m_pDropTarget;

	bool	m_bHidden;
	bool	m_bInitialized;
	bool	m_bNoScroll;

	int		m_nX, m_nY;
	int		m_nWidth, m_nHeight;
	int		m_nLastItem;
	int		m_nSpacingX, m_nSpacingY;
	int		m_nOffsetPercentX, m_nOffsetPercentY;

	// PIDL address of the folder to browse
	LPITEMIDLIST	m_pidlFolder;

	char*	m_szBackground;
	bool	m_bTiled;
	
	//New Added Functions
	//---------------------------------------------
	bool	m_bExplorerDesktop;
	WNDPROC wpOrigListView_Proc;	
	
	void activateWndProc();
	void relayMouseMessage(UINT message, WPARAM wParam, LPARAM lParam);
	//---------------------------------------------


};

#endif
